<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/include/MTQueue.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_m_t_queue_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">MTQueue.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;atomic&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &lt;condition_variable&gt;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;tuple&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160; </div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_queue.html">   16</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classsiggen_1_1_m_t_queue.html">MTQueue</a></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    {</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        std::mutex m_Mutex;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        std::condition_variable m_CondVarWaitForDequeue;                </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        std::condition_variable m_CondVarWaitForEnqueue;                </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        <span class="keywordtype">bool</span> m_Terminate { <span class="keyword">false</span> };</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="keywordtype">size_t</span> m_Size { 0 };                                            </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        std::vector&lt;std::tuple&lt;size_t, std::vector&lt;char&gt;&gt;&gt; m_Data;      </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">protected</span>:</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_queue.html#a38afc32fe3ff55fe04547c3766fc7421">   29</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#a38afc32fe3ff55fe04547c3766fc7421">IsWorkReady</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_Size &gt; 0; }</div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_queue.html#acd9c2ada8a8557be458702a03fd1348a">   31</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#acd9c2ada8a8557be458702a03fd1348a">IsFull</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_Size == m_Data.size(); }</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <a class="code" href="classsiggen_1_1_m_t_queue.html#a93ce221a4c3d88f219a8a1e59e53c52f">MTQueue</a> (<span class="keywordtype">size_t</span> n, <span class="keywordtype">size_t</span> blockSize);</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">Enqueue</a> (<span class="keywordtype">size_t</span> blockIndex, std::vector&lt;char&gt; &amp; data);</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">Dequeue</a> (<span class="keywordtype">size_t</span> &amp; blockIndex, std::vector&lt;char&gt; &amp; data);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#a70fe66d834087214efffe789fb296289">Terminate</a> ();</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    };</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_a38afc32fe3ff55fe04547c3766fc7421"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#a38afc32fe3ff55fe04547c3766fc7421">siggen::MTQueue::IsWorkReady</a></div><div class="ttdeci">bool IsWorkReady() const</div><div class="ttdoc">queue has at least one item</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8h_source.html#l00029">MTQueue.h:29</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_a93ce221a4c3d88f219a8a1e59e53c52f"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#a93ce221a4c3d88f219a8a1e59e53c52f">siggen::MTQueue::MTQueue</a></div><div class="ttdeci">MTQueue(size_t n, size_t blockSize)</div><div class="ttdoc">creates queue for n blocks with each block of blockSize bytes</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00007">MTQueue.cpp:7</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_ac47b8a0a7ad4c4334dfed8596aea1651"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">siggen::MTQueue::Enqueue</a></div><div class="ttdeci">void Enqueue(size_t blockIndex, std::vector&lt; char &gt; &amp;data)</div><div class="ttdoc">enqueues data or waits</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00018">MTQueue.cpp:18</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html">siggen::MTQueue</a></div><div class="ttdoc">synchronized data passing between producer and consumer threads</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8h_source.html#l00016">MTQueue.h:16</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_acd9c2ada8a8557be458702a03fd1348a"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#acd9c2ada8a8557be458702a03fd1348a">siggen::MTQueue::IsFull</a></div><div class="ttdeci">bool IsFull() const</div><div class="ttdoc">queue is full</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8h_source.html#l00031">MTQueue.h:31</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_a70fe66d834087214efffe789fb296289"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#a70fe66d834087214efffe789fb296289">siggen::MTQueue::Terminate</a></div><div class="ttdeci">void Terminate()</div><div class="ttdoc">sets terminate flag and notify waiting thread(s)</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00074">MTQueue.cpp:74</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_ab383d104dbf22cb80df5fa826c23573b"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">siggen::MTQueue::Dequeue</a></div><div class="ttdeci">void Dequeue(size_t &amp;blockIndex, std::vector&lt; char &gt; &amp;data)</div><div class="ttdoc">dequeues data or waits</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00042">MTQueue.cpp:42</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_5a30104352ef4255dc24354b02eb2d20.html">include</a></li><li class="navelem"><b>MTQueue.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
